package cz.upol.fpj.lecture12.collections

object SortAlgs {
  def qsort[T](xs: Traversable[T])(implicit ord: Ordering[T]): Traversable[T] = {
    if (xs.size <= 1) xs
    else {
      val pivot = xs.head
      val (l, h) = xs partition (x => ord.lt(x, pivot))
      qsort(l) ++ List(pivot) ++ qsort(h.tail)
    }
  }
  
  def mergesort[T](xs: List[T])(implicit ord: Ordering[T]): List[T] = {
    def merge[T](l: List[T], r: List[T])(implicit ord: Ordering[T]): List[T] = (l, r) match {
      case (l, Nil) => l
      case (Nil, r) => r
      case (lHead :: lTail, rHead :: rTail) =>
        if (ord.lt(lHead, rHead)) lHead :: merge(lTail, r)
        else rHead :: merge(l, rTail)
    }
    
    if (xs.size <= 1) xs
    else {
      val (l, r) = xs splitAt (xs.size / 2)
      merge(mergesort(l), mergesort(r))
    }
  }
  
  
  def main(args: Array[String]): Unit = {
    println(qsort(Array(10, 2, -5, 7, 8, 3)))
    
    println(1 :: 2 :: 3 :: Nil)
    println(mergesort(List(10, 2, -5, 7, 8, 3)))
  }
}