package cz.upol.fpj.lecture12.implicits

class Rational(n: Int, d: Int) {
  
  private val g = gcd(n.abs, d.abs)
  val numer = n / g;
  val denom = d / g;
  def this(n: Int) = this(n, 1)
  
  override def toString = numer + "/" + denom

  def add(that: Rational): Rational = {
    new Rational(numer * that.denom + that.numer * denom, denom * that.denom)
  }
  
  def +(that: Rational): Rational = this add that
  
  private def gcd(a: Int, b: Int): Int = {
    if (b == 0) a
    else gcd(b, a % b);
  }
}

object Rational {
  val ZERO = new Rational(0)
  implicit def intToRational(i: Int) = new Rational(i)
  def apply(n: Int, d: Int) = new Rational(n, d)
}