package cz.upol.fpj.lecture12.prolog

object PrologTest {
  def main(args: Array[String]): Unit = {
    val prolog = new Prolog();

    // prevzato z http://www.cs.toronto.edu/~sheila/384/w11/simple-prolog-examples.html
    prolog.add(CompoundTerm("male", Seq(Atom("james1"))))
    prolog.add(CompoundTerm("male", Seq(Atom("charles1"))))
    prolog.add(CompoundTerm("male", Seq(Atom("charles2"))))
    prolog.add(CompoundTerm("male", Seq(Atom("james2"))))
    prolog.add(CompoundTerm("male", Seq(Atom("george1"))))

    prolog.add(CompoundTerm("female", Seq(Atom("catherine"))))
    prolog.add(CompoundTerm("female", Seq(Atom("elizabeth"))))
    prolog.add(CompoundTerm("female", Seq(Atom("sophia"))))

    prolog.add(CompoundTerm("parent", Seq(Atom("charles1"), Atom("james1"))))
    prolog.add(CompoundTerm("parent", Seq(Atom("elizabeth"), Atom("james1"))))
    prolog.add(CompoundTerm("parent", Seq(Atom("charles2"), Atom("charles1"))))
    prolog.add(CompoundTerm("parent", Seq(Atom("james2"), Atom("charles1"))))
    prolog.add(CompoundTerm("parent", Seq("sophia", "elizabeth")))
    prolog add "parent" :: List("george1", "sophia") 

    prolog.add(
      CompoundTerm("sibling", Seq(Var("A"), Var("B"))),
      CompoundTerm("parent", Seq(Var("A"), Var("X"))),
      CompoundTerm("parent", Seq(Var("B"), Var("X"))))

    prolog.add(
      CompoundTerm("grandparent", Seq(Var("A"), Var("B"))),
      CompoundTerm("parent", Seq(Var("A"), Var("X"))),
      CompoundTerm("parent", Seq(Var("X"), Var("B"))))

//  val q = CompoundTerm("grandparent", Seq(Var("Z"), Atom("james1")))
//  val q = CompoundTerm("grandparent", Seq("sophia", "Z"))
    val q = "grandparent" :: List("sophia", "Z")

    val res = prolog.query(q)

    println(res)
  }

  private implicit def stringToTerm(s: String): Term =
    if (s.charAt(0).isUpper) Var(s) else Atom(s)
    
  private implicit def listToCompoung(l: List[String]): Term = CompoundTerm(l.head, l.tail map stringToTerm)
}